% -*- MATLAB -*-
% Time-stamp: "2015-11-21 04:48:27 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function c = atan2( b, a )

  % temporary storage
  worksize = uint32( (exfloat.size64 + 1)*5 );
  work = zeros(worksize,1, 'uint64');

  invtablesize = uint32( (exfloat.size64 + 2) * 500 );
  invtable_atan = zeros(invtablesize,1, 'uint64');

  [row,col] = size( a );
  [row2,col2] = size( b );
  
  if ( (row ~= row2) | (col ~= col2) )
    error('Two operands should be same size.');
    return;
  end

  for n=1:col
    for m=1:row

      x = exfloat( a(m,n) );
      y = exfloat( b(m,n) );
      c(m,n) = exfloat();
      
      if ( x > 0 )

        yx = y / x;
        exflib_float_atan(c(m,n).num, yx.num, exfloat.precision64, work, invtable_atan);

      elseif ( (y >= 0) & (x < 0) )
        
        yx = y / x;
        exflib_float_atan(c(m,n).num, yx.num, exfloat.precision64, work, invtable_atan);
        PI = exfloat( '#PI' );
        exflib_float_add(c(m,n).num, c(m,n).num, PI.num, exfloat.precision64);
        
      elseif ( (y < 0) & (x < 0) )
        
        yx = y / x;
        exflib_float_atan(c(m,n).num, yx.num, exfloat.precision64, work, invtable_atan);
        PI = exfloat( '#PI' );
        exflib_float_sub(c(m,n).num, c(m,n).num, PI.num, exfloat.precision64);

      elseif ( (y > 0) & (x == 0) )

        c(m,n) = exfloat( '#PI/2' );

      elseif ( (y < 0) && (x == 0) )

        c(m,n) = exfloat( '-#PI/2' );

      end
      
      % default: y == 0 & x == 0
      % c(m,n) = 0;

    end
  end

end

%  roundinfo = 0;
%  exflib_float_round_near(c.num, roundinfo, exfloat.precision64);

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
