% -*- MATLAB -*-
% Time-stamp: "2018-08-12 10:45:11 fujiwara"
%----------------------------------------------------------------------
%  Copyright (C) 2018, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function d = det( a )

  [row,col] = size( a );

  assert( row == col );

  exfloat_size = 1+exfloat.precision64();

  mat = uint64( 1:row*col*exfloat_size );
  v   = uint64( 1:exfloat_size );

  for m=1:row
    for n=1:col
      idx = ((m-1)*col+(n-1))*exfloat_size;
      mat( idx+1:idx+exfloat_size ) = a(m,n).num(1:exfloat_size);
    end
  end   

  exflib_mex_det(mat, row, exfloat.precision64(), v);

  d = exfloat();
  d.num = v( 1:exfloat_size );

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
