% -*- MATLAB -*-
% Time-stamp: "2018-08-16 23:45:10 fujiwara"
%----------------------------------------------------------------------
%  Copyright (C) 2018, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function mat = horzcat( a, varargin )

  [row,col] = size( a );

  for n=1:length(varargin)

    [rown,coln] = size( varargin{n} );

    if rown ~= row
      error('horzcat: cat: dimension mismatch');
      return;
    end

    col = col + coln; 

  end

  mat(row,col) = exfloat();

  [row,col] = size( a );

  mat(:,1:col) = a;
  idx = col;

  for n=1:length(varargin)
    [rown,coln] = size( varargin{n} );
    mat(:,idx+1:idx+coln) = varargin{n};
    idx = idx + coln;
  end

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
