% -*- MATLAB -*-
% Time-stamp: "2015-11-27 18:33:59 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function b = inv( a )

  exfloat_size = 1+exfloat.precision64;

  [arow,acol] = size( a );
  
  if ( arow ~= acol )
    error ('Operand shoud be a square matrix.');
    return;
  end
  
  %------------------------------
  % a is scalar
  %------------------------------
  if ( arow == 1 )
    one = exfloat( 1 );
    x   = exfloat( a );
    b   = exfloat();
    exflib_float_div(b.num, one.num, x.num, exfloat.precision64);
    return;
  end
  
  array = uint64( 1:2*acol*arow*exfloat_size );
  work  = uint64( 1:10*exfloat_size );

  % pack a
  for m=1:arow
    for n=1:acol
      idx = ( (m-1)*2*arow + (n-1) ) * exfloat_size;
      array( idx+1:idx+exfloat_size ) = a(m,n).num( 1:exfloat_size );
      % d = exfloat( b(m,n) );
      % array( idx+1:idx+exfloat_size ) = d.num( 1:exfloat_size );
    end
  end

  % execute
  exflib_mex_inv(array, arow, exfloat.precision64, work);

  % unpack b
  for m=1:arow
    for n=1:acol
      idx = ( (m-1)*2*arow + (acol+n-1) ) * exfloat_size;
      b(m,n) = exfloat();
      b(m,n).num( 1:exfloat_size ) = array( idx+1:idx+exfloat_size );
    end
  end

  return;

%  roundinfo = 0;
%  exflib_float_round_near(c.num, roundinfo, exfloat.precision64);

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
