% -*- MATLAB -*-
% Time-stamp: "2015-08-05 20:06:57 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function c = ldivide( b, a )

  [arow,acol] = size( a );
  [brow,bcol] = size( b );

  %------------------------------
  % a is scalar
  %------------------------------
  if ( (arow == 1) & (acol == 1) )

    x = exfloat( a );

    for m=1:brow
      for n=1:bcol

        y = exfloat( b(m,n) );
        c(m,n) = exfloat();
        exflib_float_div(c(m,n).num, x.num, y.num, exfloat.precision64);

      end
    end
    return
  end

  %------------------------------
  % b is scalar
  %------------------------------
  if ( (brow == 1) & (bcol == 1) )

    y = exfloat( b );

    for m=1:arow
      for n=1:acol

        x = exfloat( a(m,n) );
        c(m,n) = exfloat();
        exflib_float_div(c(m,n).num, x.num, y.num, exfloat.precision64);

      end
    end
    return
  end

  %------------------------------
  % Both a and b are arrays
  %------------------------------
  for m=1:arow
    for n=1:acol

      x = exfloat( a(m,n) );
      y = exfloat( b(m,n) );
      c(m,n) = exfloat();

      exflib_float_div(c(m,n).num, x.num, y.num, exfloat.precision64);

      end
    end
  end

end

%  roundinfo = 0;
%  exflib_float_round_near(c.num, roundinfo, exfloat.precision64);

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
