% -*- MATLAB -*-
% Time-stamp: "2015-08-05 20:10:31 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function c = le( a, b )

  [arow,acol] = size( a );
  [brow,bcol] = size( b );

  %------------------------------
  % a is scalar
  %------------------------------
  if( (arow == 1) & (acol == 1) )

    x = exfloat( a );

    for n=1:acol
      for m=1:arow

        y = exfloat( b(m,n) );
        c(m,n) = zeros(1,1,'int32');

        if exflib_float_lt(y.num, x.num, exfloat.precision64) == 0
          c(m,n) = 1;
        end

      end
    end

    return

  end

  %------------------------------
  % b is scalar
  %------------------------------
  if( (brow == 1) & (bcol == 1) )

    y = exfloat( b );

    for n=1:acol
      for m=1:arow

        x = exfloat( a(m,n) );
        c(m,n) = zeros(1,1,'int32');

        if exflib_float_lt(y.num, x.num, exfloat.precision64) == 0
          c(m,n) = 1;
        end

      end
    end

    return

  end

  %------------------------------
  % Both a and b are arrays
  %------------------------------
  for n=1:acol
    for m=1:arow

      x = exfloat( a(m,n) );
      y = exfloat( b(m,n) );
      c(m,n) = zeros(1,1,'int32');

      if exflib_float_lt(y.num, x.num, exfloat.precision64) == 0
        c(m,n) = 1;
      end

    end
  end

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
