% -*- MATLAB -*-
% Time-stamp: "2015-08-05 20:12:37 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function c = ne ( a, b )

  [arow,acol] = size( a );
  [brow,bcol] = size( b );

  %------------------------------
  % a is scalar
  %------------------------------
  if( (arow == 1) & (acol == 1) )

    x = exfloat ( a );

    for n=1:bcol
      for m=1:brow

	y = exfloat( b(m,n) );
        c(m,n) = zeros(1,1,'int32');

        % detecting zero
        if iszero(x) & iszero(y)
          c(m,n) = 1;
          continue;
        end

        for k=1:exfloat.size64
          if( x.num(k) ~= y.num(k) )
            c(m,n) = 1;
            break;
          end
        end

      end
    end

    return

  end

  %------------------------------
  % b is scalar
  %------------------------------
  if( (brow == 1) & (bcol == 1) )

    y = exfloat ( b );

    for n=1:bcol
      for m=1:brow

	x = exfloat( a(m,n) );
        c(m,n) = zeros(1,1,'int32');

        % detecting zero
        if iszero(x) & iszero(y)
          c(m,n) = 1;
          continue;
        end

        for k=1:exfloat.size64
          if( x.num(k) ~= y.num(k) )
            c(m,n) = 1;
            break;
          end
        end

      end
    end

    return

  end

  %------------------------------
  % Both a and b are arrays
  %------------------------------
  for n=1:acol
    for m=1:arow

      x = exfloat( a(m,n) );
      y = exfloat( b(m,n) );
      c(m,n) = zeros(1,1,'int32');

      % detecting zero
      if iszero(x) & iszero(y)
        c(m,n) = 1;
        continue;
      end

      for k=1:exfloat.size64
        if( x.num(k) ~= y.num(k) )
          c(m,n) = 1;
          break;
        end
      end

    end
  end

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
