% -*- MATLAB -*-
% Time-stamp: "2015-08-07 21:09:54 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function str = num2str( x, varargin )

    output_prec = exfloat.default_output_precision;
    output_fmt  = exfloat.default_output_format;

    if ( length(varargin) >= 1 & isa(varargin{1}, 'numeric') )

      output_prec = uint64( varargin{1} );
      output_fmt  = 'g';

    elseif ( length(varargin) >= 1 & isa(varargin{1}, 'char') )

      [ output_prec, output_fmt ] = exfloat.parse_fmt ( varargin{1} );

    elseif ( length(varargin) >= 1 )

      disp('Warning: illeagal usage : num2str()');

    end

    [ row, col ] = size( x );

    %------------------------------
    % scalar variable
    %------------------------------
    if (row == 1) & (col == 1)
      str = num2str_scalar( x, output_prec, output_fmt );
      return;
    end

    %------------------------------
    % array
    %------------------------------
    str = '';
    for m=1:row
      for n=1:col
        str2 = num2str_scalar( x(m,n), output_prec, output_fmt );
        str  = sprintf('%s\t%s', str, str2);
      end
      str = sprintf('%s\n', str);
    end

end % function str=num2str( x, fmt )

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
