% -*- MATLAB -*-
% Time-stamp: "2015-08-05 20:13:25 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function p = power( a, b )

  % temporary storage
  worksize = uint32( (exfloat.size64 + 1)*5 );
  work = zeros(worksize,1, 'uint64');

  invtablesize = uint32( (exfloat.size64 + 2) * 500 );
  invtable = zeros(invtablesize,1, 'uint64');

  [arow,acol] = size( a );
  [brow,bcol] = size( b );

  %------------------------------
  % b is a scalar
  %------------------------------
  if ( (brow == 1) & (bcol == 1) )

    y = exfloat( b );

    for n=1:acol
      for m=1:arow

        x = exfloat( a(m,n) );
        p(m,n) = exfloat();
        exflib_float_pow(p(m,n).num, x.num, y.num, exfloat.precision64, work, invtable);

      end
    end

    return

  end

  %------------------------------
  % b is a matrix
  %------------------------------
  for n=1:acol
    for m=1:arow

      x = exfloat( a(m,n) );
      y = exfloat( b(m,n) );
      p(m,n) = exfloat();
      exflib_float_pow(p(m,n).num, x.num, y.num, exfloat.precision64, work, invtable);

    end
  end

end

%  roundinfo = 0;
%  exflib_float_round_near(c.num, roundinfo, exfloat.precision64);

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
