% -*- MATLAB -*-
% Time-stamp: "2015-08-05 20:14:14 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function b = sinh( a )

  e1 = exp( a );
  e2 = 1 / e1;
  b  = e1 - e2;
  
  [row,col] = size( a );

  % divide by 2
  for n=1:col
    for m=1:row
      
      if iszero( a(m,n) )
        b(m,n) = exfloat(0);
        continue
      end

      if bitand( b(m,n).num(1), exfloat.EXP_MASK ) ~= 0
        b(m,n).num(1) = b(m,n).num(1) - 1;
      end
      
    end
  end

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
