% -*- MATLAB -*-
% Time-stamp: "2018-08-16 23:43:41 fujiwara"
%----------------------------------------------------------------------
%  Copyright (C) 2018, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function mat = vertcat( a, varargin )

  [row,col] = size( a );

  for n=1:length(varargin)

    [rown,coln] = size( varargin{n} );

    if coln ~= col
      error('vertcat: cat: dimension mismatch');
      return;
    end

    row = row + rown;

  end

  mat(row,col) = exfloat();

  [row,col] = size( a );

  mat(1:row,:) = a;
  idx = row;

  for n=1:length(varargin)
    [rown,coln] = size( varargin{n} );
    mat(idx+1:idx+rown,:) = varargin{n};
    idx = idx + rown;
  end

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
