/* -*- C -*- */
/* Time-stamp: "2015-06-30 22:36:16 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const a = (unsigned long long*)mxGetData( prhs[0] );
  unsigned long long *const b = (unsigned long long*)mxGetData( prhs[1] );
  const size_t N = mxGetScalar( prhs[2] );

  long *ret;

#if 0
  /* For old version, compile by */
  /*    mex -compatibleArrayDims exflib_float_lt.c */
  int rows, cols;
#else
  /* New version, compile by */
  /*    mex -largeArrayDims exflib_float_lt.c */
  mwSize rows, cols;
#endif  
  
  rows = cols = 1;
  
  /* *plhs = mxCreateDoubleMatrix(1,1,mxREAL); */
  *plhs = mxCreateNumericArray(rows,&cols,mxINT32_CLASS,mxREAL);
  ret = (long *)mxGetData(*plhs);
  *ret = exflib_float_lt( a, b, N );

  return;
}

/* End of file */
