/* -*- C -*- */
/* Time-stamp: "2015-11-08 20:29:37 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const c = (unsigned long long*)mxGetData( prhs[0] );  
  unsigned long long *const a = (unsigned long long*)mxGetData( prhs[1] );  
  const size_t N    = mxGetScalar( prhs[2] );  /* size */
  const size_t pr64 = mxGetScalar( prhs[3] );  /* precision64 */
  unsigned long long *const w = (unsigned long long*)mxGetData( prhs[4] );

  unsigned long long *const b = a + N*(1+pr64);

  int p, i;

  for(p = 0; p <= pr64; p++)
    c[p] = 0;

  for(i = 0; i < N; i++){
    size_t idx = i*(1+pr64);
    exflib_float_mul(w, a+idx, b+idx, pr64);
    exflib_float_add(c, c, w, pr64);
  }
  
  /* exflib_ulong roundinfo = exflib_float_add( c, a, b, N ); */
  /* exflib_float_round_near(c, roundinfo, N); */

  return;
}

/* End of file */
