/* -*- C -*- */
/* Time-stamp: "2015-11-08 20:29:37 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const h = (unsigned long long*)mxGetData( prhs[0] );  
  const size_t N    = mxGetScalar( prhs[1] );  /* size */
  const size_t pr64 = mxGetScalar( prhs[2] );  /* precision64 */

  int i, j, p;

  h[0] = 0x3fffffffffffffffULL;
  for(p = 1; p <= pr64; p++)
    h[p] = 0;

  for(i = 1; i < N; i++){
    size_t idx = i*(1+pr64);
    exflib_float_idiv(h+idx, h, i+1, pr64);
  }

  /* exflib_ulong roundinfo = exflib_float_add( c, a, b, N ); */
  /* exflib_float_round_near(c, roundinfo, N); */

  return;
}

/* End of file */
