/* -*- C -*- */
/* Time-stamp: "2015-11-18 21:29:26 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"

/* exflib_mex_prod_matrix(p_array, a_array, arow, acol, exfloat.precision64); */

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const c = (unsigned long long*)mxGetData( prhs[0] );  
  unsigned long long *const a = (unsigned long long*)mxGetData( prhs[1] );  
  const size_t arow = mxGetScalar( prhs[2] );
  const size_t acol = mxGetScalar( prhs[3] );
  const size_t pr64 = mxGetScalar( prhs[4] );  /* precision64 */

  int p, i, j;

  for(j = 0; j < acol; j++){

    unsigned long long *const cc = c + j*(1+pr64);
    const unsigned long long *const aa = a + j*arow*(1+pr64);

    for(p = 0; p <= pr64; p++)
      cc[p] = aa[p];

    for(i = 1; i < arow; i++){
      const size_t idx = ( j*arow + i ) * (1+pr64);
      exflib_float_mul(cc, cc, a+idx, pr64);
    }
  }
  
  /* exflib_ulong roundinfo = exflib_float_add( c, a, b, N ); */
  /* exflib_float_round_near(c, roundinfo, N); */

  return;
}

/* End of file */
