/* -*- C -*- */
/* Time-stamp: "2015-11-18 21:25:10 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"

/* exflib_mex_sum_v(sum.num, a_array, N, exfloat.precision64); */

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const s = (unsigned long long*)mxGetData( prhs[0] );  
  unsigned long long *const a = (unsigned long long*)mxGetData( prhs[1] );  
  const size_t N    = mxGetScalar( prhs[2] );  /* size */
  const size_t pr64 = mxGetScalar( prhs[3] );  /* precision64 */

  int p, i;

  for(p = 0; p <= pr64; p++)
    s[p] = a[p];

  for(i = 1; i < N; i++){
    const size_t idx = i*(1+pr64);
    exflib_float_add(s, s, a+idx, pr64);
  }
  
  /* exflib_ulong roundinfo = exflib_float_add( c, a, b, N ); */
  /* exflib_float_round_near(c, roundinfo, N); */

  return;
}

/* End of file */
