/* -*- C -*- */
/* Time-stamp: "2015-11-08 20:29:37 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"

/* exflib_mex_times_vv(c_array, a_array, b_array, N, exfloat.precision64); */

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const c = (unsigned long long*)mxGetData( prhs[0] );  
  unsigned long long *const a = (unsigned long long*)mxGetData( prhs[1] );  
  unsigned long long *const b = (unsigned long long*)mxGetData( prhs[2] );  
  const size_t N    = mxGetScalar( prhs[3] );  /* size */
  const size_t pr64 = mxGetScalar( prhs[4] );  /* precision64 */

  int i;

  for(i = 0; i < N; i++){
    size_t idx = i*(1+pr64);
    exflib_float_mul(c+idx, a+idx, b+idx, pr64);
  }
  
  /* exflib_ulong roundinfo = exflib_float_add( c, a, b, N ); */
  /* exflib_float_round_near(c, roundinfo, N); */

  return;
}

/* End of file */
