/* -*- C -*- */
/* Time-stamp: "2015-06-27 23:12:00 user" */
/*----------------------------------------------------------------------*/
/*  Copyright (C) 2015, FUJIWARA Hiroshi                                */
/*    <fujiwara@acs.i.kyoto-u.ac.jp>                                    */
/*----------------------------------------------------------------------*/
#include "mex.h"
#include "exfloat.h"
#include <string.h>

enum { bufsize = 65536 };

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  unsigned long long *const flag = (unsigned long long*)mxGetData( prhs[0] );
  unsigned long long *const b64  = (unsigned long long*)mxGetData( prhs[1] );
  long long *const deci_pow      = (long long*)mxGetData( prhs[2] );

  char deci_f[bufsize];
  memset(deci_f, '\0', bufsize);

  exflib_scientific_format(*flag, b64, *deci_pow, deci_f);

  plhs[0] = mxCreateString(deci_f);

  return;
}

/* End of file */
